{**********************************************************************
                  PilotLogic Software House

 Package pl_Win_WMI
 This file is part of CodeTyphon Studio (https://www.pilotlogic.com/)
***********************************************************************}

unit AllWinWMIregister;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,

  ComponentEditors, PropEdits, LResources,
  UConstantes,
  CBIOSInfo, CDiskDriveInfo, CProcessorInfo, CCDROMDriveInfo,
  CKeyboardInfo, CPrinterInfo, CBatteryInfo, CSoundDeviceInfo,
  COperatingSystemInfo, CPointingDeviceInfo, CPhysicalMemoryInfo,
  CProcessInfo, CServiceInfo, CDesktopMonitorInfo, CComputerSystemInfo,
  CStartupCommandInfo, CNetworkAdapterInfo, CUserAccountInfo, CShareInfo,
  CPrintJobInfo, CUSBControllerInfo, CDiskPartitionInfo, CFanInfo, CPnPEntityInfo,
  CDisplayConfigurationInfo, CProductInfo, CVideoControllerInfo,
  CEnvironmentInfo,
  CWMISQL,
  WbemScripting_TLB,
  UTAboutProp;

procedure Register;

implementation

{$R AllWinWMIregister.res}

procedure Register;
begin

  // Hardware
  RegisterComponents('Win_WMI Hardware', [
                                            TBiosInfo,
                                            TDiskDriveInfo,
                                            TDiskPartitionInfo,
                                            TProcessorInfo,
                                            TCDROMDriveInfo,
                                            TKeyboardInfo,
                              	            TPrinterInfo,
                                            TBatteryInfo,
                                            TNetworkAdapterInfo,
                                            TSoundDeviceInfo,
                                            TPointingDeviceInfo,
                                            TUSBControllerInfo,
                                            TPhysicalMemoryInfo,
                                            TFanInfo,
                                            TPnPEntityInfo]);

  // Software
  RegisterComponents('Win_WMI Software', [
                                            TWMISQL,
                                            TPrintJobInfo,
                                            TOperatingSystemInfo,
                                            TProcessInfo,
                                	    TServiceInfo,
                                            TDesktopMonitorInfo,
                                            TEnvironmentInfo,
                                            TComputerSystemInfo,
                                            TStartupCommandInfo,
                                            TUserAccountInfo,
                                            TShareInfo,
                                            TDisplayConfigurationInfo,
	                                    TProductInfo,
                                            TVideoControllerInfo]);
                
  // ActiveX
  RegisterComponents('Win_WMI ActiveX',  [
                                            TSWbemLocator,
                                            TSWbemNamedValueSet,
                                            TSWbemObjectPath,
                                            TSWbemLastError,
                                            TSWbemSink,
                                            TSWbemDateTime,
                                            TSWbemRefresher]);

  // SQL
  //RegisterComponents(GLIBWMI_PACKAGE_WMISQL, [TWMISQL]);

  RegisterPropertyEditor(TypeInfo(TStrings), TWMISQL, 'Properties', TValueListPropertyEditor);




end;

end.

